﻿using System;
using System.Collections.Generic;
using System.Collections.ObjectModel;
using System.ComponentModel;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Xamarin.Forms;

namespace TextInput
{
    // Learn more about making custom code visible in the Xamarin.Forms previewer
    // by visiting https://aka.ms/xamarinforms-previewer
    [DesignTimeVisible(true)]
    public partial class MainPage : ContentPage
    {
      private MainContentView contentView;

      public MainPage()
      {
          InitializeComponent();

      }

      private void Button_OnClicked(object sender, EventArgs e)
      {
        //this.TabContent.IsVisible = !this.TabContent.IsVisible;
        if (this.TabContent.Content == null)
        {
          if (this.contentView == null)
          {
            this.contentView = new MainContentView();
          }

          this.TabContent.Content = contentView;
        }
        else
        {
          this.TabContent.Content = null;
          //this.contentView = null;
        }
      }
    }

    public class ViewModel : INotifyPropertyChanged
    {
        private ObservableCollection<Model> featuredStories;

        #region Constructor

        public ViewModel()
        {
            this.FeaturedStories = new ObservableCollection<Model>()
            {
                new Model()
                {
                    ImagePath = "ArticleImage2.jpg",
                    Name = "Learning to Reset",
                },
                new Model()
                {
                    ImagePath = "ArticleImage3.jpg",
                    Name = "Holistic Approach to UI Design",
                },
                new Model()
                {
                    ImagePath = "ArticleImage4.jpg",
                    Name = "Guiding Your Flock to Success",
                },
                new Model()
                {
                    ImagePath = "ArticleImage5.jpg",
                    Name = "Be a Nurturing, Fierce Team Leader",
                },
                new Model()
                {
                    ImagePath = "ArticleImage6.jpg",
                    Name = "Holistic Approach to UI Design",
                }
            };

        }
        #endregion

        #region Event

        /// <summary>
        /// The declaration of property changed event.
        /// </summary>
        public event PropertyChangedEventHandler PropertyChanged;

        #endregion

        #region Public Properties
        /// <summary>
        /// Gets or sets the property has been bound with the rotator view which displays the articles featured stories items.
        /// </summary>
        public ObservableCollection<Model> FeaturedStories
        {
            get
            {
                return featuredStories;
            }

            set
            {
                if (this.featuredStories == value)
                {
                    return;
                }

                this.featuredStories = value;
                this.NotifyPropertyChanged("FeaturedStories");
            }
        }

        public void NotifyPropertyChanged(string propertyName)
        {
            this.PropertyChanged?.Invoke(this, new PropertyChangedEventArgs(propertyName));
        }


        #endregion
    }

    public class Model
    {
        public string ImagePath { get; set; }
        public string Name { get; set; }
    }
}
